<?php

require_once 'connect.php';
require_once 'inc/messages.php';

// retorna array com lista, ou false se deu erro
function saldos_enderecar_getAll() {
  global $conexao;
  $sql = 'select * from erpc_saldos_enderecar where st_ativo=?';
  $values[] = '1';
  $result = _prepareAndQuery($sql, $values);
  return $result;
}

// retorna array associativo com objeto, ou false se deu erro/não encontrar
function saldos_enderecar_getById($id) {
  global $conexao;
  $sql = 'select * from erpc_saldos_enderecar where id=? and st_ativo=1';
  $values[] = $id;
  $result = _prepareAndQuery($sql, $values);
  if ($result !== false) {
    if (count($result) === 1) {
      $result = $result[0];
      $itens = saldos_enderecar_item_getById($id);
      // se não tiver itens, cria um array vazio
      if ($itens === false) {
        $result = false;
        addError('Erro ao carregar os itens');
      } else {
        $result['itens'] = $itens;
        // já formato os campos aqui? por hora sim...
        foreach($result as $k => $v) {
          $result[$k] = sgcws_format_field($k, $v);
        }
      }
    } else {
      $result = false;
      addError('Id não encontrado');
    }
  }

  return $result;
}

// retorna array associativo com objeto, ou false se deu erro/não encontrar
function saldos_enderecar_item_getById($id_pai) {
  global $conexao;
  $sql = 'select tpi.*, p.ds_produto from erpc_saldos_enderecar_item tpi join erpc_saldos p on (p.id = tpi.id_produto) where tpi.id_saldos_enderecar=?';
  $values[] = $id_pai;
  $result = _prepareAndQuery($sql, $values);
  return $result;
}

// insere novo
function saldos_enderecar_insert($saldos_enderecar, &$error=null) {
  global $conexao;
  $ok = false;
  $sql = 'insert into erpc_saldos_enderecar ';
  $campos = array('ds_documento', 'ds_documento_descricao', 'id_tipo_movimentacao', 'st_ativo');
  $values = array();
  foreach($campos as $campo) {
    $values[] = $saldos_enderecar[$campo];
  }
  $sql .= '(' . implode(',', $campos) . ') values (' . trim(str_repeat('?,', count($values)), ',') . ')';
  $ok = _prepareAndExecute($sql, $values, $error);
  if ($ok !== false) {
    $saldos_enderecar['id'] = mysqli_insert_id($conexao);
    $ok = saldos_enderecar_item_insert($saldos_enderecar, $error);
    if ($ok && $error === null) {
      addMessage('Inserido com sucesso');
    }
  }
  return $ok;
}

// insere novo item
function saldos_enderecar_item_insert($saldos_enderecar, &$error=null) {
  global $conexao;
  $ok = false;
  $itens = $saldos_enderecar['itens'];
  if (count($itens) > 0) {
    $sql = 'insert into erpc_saldos_enderecar_item ';
    $campos = array('id_saldos_enderecar', 'id_produto', 'id_local_estoque', 'nr_qtde', 'st_ativo');
    $sql .= '(' . implode(',', $campos) . ') values ';
    $sql .= '(' . trim(str_repeat('?,', count($campos)), ',') . ')';
    $values = array();
    foreach($itens as $item) {
      if (!empty($item['id_produto'])) {
        $item['id_saldos_enderecar'] = $saldos_enderecar['id'];
        foreach($campos as $campo) {
          if (in_array($campo, ['st_ativo'])) {
            $values[] = isset($item[$campo]) ? '1' : '0';
          } else {
            $values[] = $item[$campo];
          }
        }
      }
    }
    // remove última ','
    if (empty($values)) {
      // nada para inserir
      $ok = true;
    } else {
      $ok = _prepareAndExecute($sql, $values, $error, true);
    }
  } else {
    // nada para inserir
    $ok = true;
  }
  return $ok;
}

// atualiza o objeto passado no bd
function saldos_enderecar_update($saldos_enderecar) {
  global $conexao;
  $ok = false;
  $sql = 'update erpc_saldos_enderecar set ';
  $campos = array('id_empresa', 'id_regiao', 'ds_saldos_enderecar', 'dh_inicio', 'dh_fim', 'ds_pagamento', 'ds_tipo_horario', 'st_ativo');
  $values = array();
  foreach($campos as $campo) {
    $sql .= $campo . '=?,';
    $values[] = $saldos_enderecar[$campo];
  }
  $sql = trim($sql, ',');
  $sql .= ' where id = ?';
  $values[] = $saldos_enderecar['id'];
  $ok = _prepareAndExecute($sql, $values);
  if ($ok !== false) {
    $ok = saldos_enderecar_item_update($saldos_enderecar);
    if ($ok !== false) {
      addMessage('Atualizado com sucesso');
    }
  }
  return $ok;
}

// atualiza os itens do objeto passado no bd, apaga tudo e insere de novo
function saldos_enderecar_item_update($saldos_enderecar) {
  global $conexao;
  $ok = false;
  $sql = 'delete from erpc_saldos_enderecar_item where id_saldos_enderecar=?';
  $values = array($saldos_enderecar['id']);
  $ok = _prepareAndExecute($sql, $values);
  if ($ok !== false) {
    $ok = saldos_enderecar_item_insert($saldos_enderecar);
  }
  return $ok;
}

function saldos_enderecar_delete($saldos_enderecar) {
  global $conexao;
  $ok = false;
  $sql = 'update erpc_saldos_enderecar set st_ativo = 0';
  $values = array();
  $sql .= ' where id = ?';
  $values[] = $saldos_enderecar['id'];
  $ok = _prepareAndExecute($sql, $values);
  if ($ok) {
    $ok = saldos_enderecar_item_delete($saldos_enderecar);
  }
  if ($ok !== false) {
    addMessage('Removido com sucesso');
  }
  return $ok;
}

function saldos_enderecar_item_delete($saldos_enderecar) {
  global $conexao;
  $ok = false;
  $sql = 'update erpc_saldos_enderecar_item set st_ativo = 0 where id_saldos_enderecar=?';
  $values = array($saldos_enderecar['id']);
  $ok = _prepareAndExecute($sql, $values);
  return $ok;
}

function saldos_enderecar_create() {
  $saldos_enderecar = array(
    'id' => '',
    'ds_documento' => '',
    'ds_documento_descricao' =>'',
    'id_tipo_movimentacao'   => '',
    'itens' => array(),
  );
  return $saldos_enderecar;
}

function saldos_enderecar_item_create() {
  $saldos_enderecar = array(
    'id_saldos_enderecar' => '',
    'id_produto' => '',
    'ds_produto' => '',
    'nr_qtde' => '',
    'id_local_estoque' => '',
    'st_ativo' => '1',
  );
  return $saldos_enderecar;
}
